/***************************************************************************
                          kohonendata.h  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifndef __KOHONENDATA
#define __KOHONENDATA

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma interface

#include <iostream>
#include <fstream>
#include <string>

using namespace std;

namespace sucs
{

class KohonenNet;

class KohonenData
{
	unsigned theDimensions, theCount;
	double **theValues;
	string *theLabels;
	mutable const KohonenNet *classifierNet;

protected:
	void Allocate(unsigned Dimensions, unsigned Count);
	void Deallocate();

public:
	void Init(unsigned Dimensions, unsigned Count);
	void setLabel(unsigned index, const string &label);
	void setValue(unsigned index, unsigned dimension, double value);
	unsigned getDimensions() const { return theDimensions; }
	unsigned getCount() const { return theCount; }

	const string &getLabel(unsigned index) const { return theLabels[index]; }

	string getClass(unsigned index, const KohonenNet &theNet) const;
	void setClassifier(const KohonenNet &theNet) const;
	string getClass(unsigned index) const;

	const double *operator[](unsigned index) const { return theValues[index]; }

	void readDat(istream &fin);

	void catenate(const KohonenData &src);

	KohonenData();
	~KohonenData();
};

}

#endif
