/***************************************************************************
                          regexp.cpp  -  description
                             -------------------
    begin                : Tue Sep 18 2001
    copyright            : (C) 2001 by Gav Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#pragma implementation

#include <string>

using namespace std;

#include <pcre.h>

#include "regexp.h"

using namespace sucs;

const string RegExp::Extract(int Index)
{
	if(theInput=="" || theExpression=="" || Index > SubSlots) return "";
	
	const char *extract;
  	pcre_get_substring(theInput.c_str(), OutVector, OutVectorSize, Index, &extract);
  	string Dummy = extract;
  	pcre_free_substring(extract);
  	return Dummy;
}

void RegExp::FreeAll()
{
	if(theInput != "")
		theInput = "";
	
	if(theExpression != "")
	{
		pcre_free(theRegExp);
		delete [] OutVector;
		theExpression = "";
	}
}

void RegExp::SetExpression(const string &newExpression)
{
	FreeAll();
	
	theExpression = newExpression;
	theRegExp = pcre_compile(theExpression.c_str(), 0, &LastErrorText, &LastErrorOffset, NULL);
	
	int count, rc;
	rc = pcre_fullinfo(theRegExp, NULL, PCRE_INFO_CAPTURECOUNT, &count);
	
	SubSlots = count;
	OutVectorSize = (count + 1) * 3;
	OutVector = new int[OutVectorSize];
}

const bool RegExp::SetInput(const string &newInput)
{
	theInput = newInput;
	return pcre_exec(theRegExp, NULL, theInput.c_str(), theInput.length(), 0, 0, OutVector, OutVectorSize) > -1;
}

