/***************************************************************************
                          stub.cpp  -  Example code for threads & semas
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Gavin James Wood
    email                : gav@indigoarchive.net
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#define __SUCS 1

#include <iostream>

using namespace std;

#include <unistd.h>

#include "threaded.h"
#include "sema.h"

using namespace sucs;

class Stub: public Threaded
{
	int A, B;
	Sema S;
	
	MemberThread threadA, threadB;
	
public:
	void threadCleanup(MemberThread *t)
	{
		cout << "Cleaning up thread " << t->name() << endl;
	}
	
	void threadBody(MemberThread *t)
	{
		cout << "Executing thread " << t->name() << endl;
		if(t == &threadA)
			usleep(A * 1000000);
		else
			if(B > 0)
				usleep(B * 1000000);
			else
			{	S.engage(); S.wait(); }
		cout << "Finished thread " << t->name() << endl;
	}

	void go()
	{
		char c[80];
		cout << "Enter time for thread A to wait: " << flush;
		cin >> A; cin.getline(c, 80);
		cout << "Enter time for thread B to wait (0 for forever): " << flush;
		cin >> B; cin.getline(c, 80);
		threadA.start();
		threadB.start();
	}

	Stub(): threadA(this, "ThreadA"), threadB(this, "ThreadB") {}
	~Stub() { cout << "Cancelling A..." << endl; threadA.cancelAndWait(); cout << "Cancelling B..." << endl; threadB.cancelAndWait(); }
};

int main()
{
	Stub s;
	s.go();
	cout << "Press enter to exit." << endl << flush;
	cin.get();
	return 0;
}
